#include "busca.c"

int busca_binaria(Item *v, Item *x, int n)
{
    int q=0;
    for(int i=0; i<n; i++){
        int j = binary_search(v, 0, n-1, x[i], crescente); 
        if(j>=0) q++;
        //int *j = bsearch(&x[i], v, n, sizeof(int), crescente); 
        //if(j) q++;
    }
    return q;
}

int busca_sequencial(Item *v, Item *x, int n)
{
    int q=0;
    for(int i=0; i<n; i++) {
        int j = search(v, 0, n-1, x[i], crescente); 
        if(j<n) q++;
    }
    return q;
}

//./a.out binaria < input/23-aleatorio
//./a.out sequencial < input/23-aleatorio
int main(int argc, char *argv[]) {
    long ms = milliseconds();
    int n;
    scanf("%d", &n);
    printf("%d elementos\n", n);
    
    int *v = malloc(n*sizeof(int));
    int *s = malloc(n*sizeof(int));
    for(int i=0; i<n; i++) {
        scanf("%d", &v[i]);
        s[i] = v[i];
    }
    printf("Tempo de leituras: %ld\n\n", milliseconds()-ms);

    ms = milliseconds();
    printf("Ordenando\n");
    qsort(v, n, sizeof(Item), crescente);

    if(is_sorted(v, 0, n-1, crescente)) printf("Ordenado\n");
    else printf("Não ordenado\n");
    printf("Tempo de ordenação: %ld\n\n", milliseconds()-ms);

    printf("Quantidade de elementos buscados: %d\n", n);    
    if(strcmp(argv[1], "sequencial")==0)
    {
        ms = milliseconds();
        printf("Quantidade de elementos encontrados: %d\n", busca_sequencial(v, s, n));
        printf("Tempo de busca: %ld\n", milliseconds()-ms);
    }
    else if(strcmp(argv[1], "binaria")==0)
    {
        ms = milliseconds();
        printf("Quantidade de elementos encontrados: %d\n", busca_binaria(v, s, n));
        printf("Tempo de busca binária: %ld\n", milliseconds()-ms);
    }
    return 0;
}


