void merge(Item *v,  int l, int m, int r, Compare comp)
{
    if(comp(&v[m], &v[m+1]) < 0) return;

    int tam = r+1-l;
    Item *aux = malloc(sizeof(Item)*tam);
    
    int i=l; 
    int j=m+1;
    int k=0; 
    
    while(i<=m && j<=r) {
        //aux[k++] = comp(&v[i], &v[j]) <= 0 ? v[i++] : v[j++];
        if(comp(&v[i], &v[j]) <= 0) 
            aux[k++] = v[i++];
        else 
            aux[k++] = v[j++];
    }

    while(i<=m) aux[k++] = v[i++];
    while(j<=r) aux[k++] = v[j++];

    /*
        while(k<tam) {
            if(i>m)
                aux[k++] = v[j++];

            else if (j>r)
                aux[k++] = v[i++];

            else if (v[i] <= v[j])
                aux[k++] = v[i++];
            else
                aux[k++] = v[j++];
        }
    */

    for(k=0, i=l; i<=r; i++, k++)
        v[i] = aux[k];
        
    free(aux);
}

void merge_sort(Item *v, int l, int r, Compare comp)
{

    //if (l >= r) return;
    if (r-l <= 15) {
      insertion(v, l, r, comp);
      return;
     }

    int m = (r+l)/2;
    
    merge_sort(v, l, m, comp);
    merge_sort(v, m+1, r, comp);
    merge(v, l, m, r, comp); 
    
}

//bottom-up
void mergeBU_sort(Item *v, int l, int r, Compare comp)
{    
    int tam = (r-l+1);

    for (int sz=1; sz<tam; sz=sz+sz)
    {
        for (int lo=l; lo<tam-sz; lo+=sz+sz)
        {
            int hi = lo+sz+sz-1;
            if(hi>tam-1) hi = tam-1;

            merge(v, lo, lo+sz-1, hi, comp); 
        }
    }
}


int partitionCORMEM(Item *v, int l, int r, Compare comp)
{
    Item pivot = v[r];
    int j = l;
    for(int i=l; i<r; i++)
    {
        if(comp(&v[i],&pivot)<0){
            exch(v[i], v[j]);
            j++;
        }
    }

    exch(v[r], v[j]);

    return j;
}

int partitionRSEDGEWICK(Item *v, int l, int r, Compare comp)
{
    int i=l-1, j=r;
    Item pivot = v[r];
    
    /*while(1)
    {
        while(comp(v[++i], pivot));
        while(comp(pivot, v[--j])) if(j==l) break;
        if(i>=j) break;
        exch(v[i], v[j]);
    }*/
    while(i<j)
    {
        while(comp(&v[++i], &pivot)<0);// && i<r);
        while(comp(&pivot, &v[--j])<0 && j>l);
        if(i<j) exch(v[i], v[j]);
    }
    exch(v[i], v[r]);
    
    return i;
}


int partitionLSEDGEWICK(Item *v,  int l, int r, Compare comp)
{  
	int i = l;
	int j = r+1;
	Item pivo = v[l];

    /*while (1)
    {
        while (comp(v[++i], pivo)) if (i == r) break;
        while (comp(pivo, v[--j])) if (j == l) break;
        if (i >= j) break;
        
        exch(v[i], v[j]);
    }*/
    while (i < j)
    {
        while (comp(&v[++i], &pivo)<0 && i<r);
        while (comp(&pivo, &v[--j])<0);// && j>l);
        if (i < j) exch(v[i], v[j]);
    }
    exch(v[l], v[j]);//atualiza a posicao do pivot

    return j;

}


void quick_sortC(Item *v,  int l, int r, Compare comp)
{
    if(r<=l) return;
    //if(r-l<=15) return; 
    //if(r-l<=15) return insertion_sort(v, l, r);

    int p = partitionCORMEM(v, l, r, comp);
    
	quick_sortC(v, l, p-1, comp);
	quick_sortC(v, p+1, r, comp);
}

void quick_sortR(Item *v,  int l, int r, Compare comp)
{
    if(r<=l) return;
    //if(r-l<=15) return;
    //if(r-l<=15) return insertion_sort(v, l, r);

    int p = partitionRSEDGEWICK(v, l, r, comp);    
	quick_sortR(v, l, p-1, comp);
	quick_sortR(v, p+1, r, comp);
}


void quick_sortL(Item *v,  int l, int r, Compare comp)
{
    if(r<=l) return;
    //if(r-l<=15) return;
    //if(r-l<=15) return insertion(v, l, r);

    int p = partitionLSEDGEWICK(v, l, r, comp);
    
	quick_sortL(v, l, p-1, comp);
	quick_sortL(v, p+1, r, comp);
}


void medianR(Item *v, int l, int r, Compare comp)
{
    int m = (l+r)/2;
    exch(v[m], v[r-1])
    if(comp(&v[l], &v[r-1]) > 0) exch(v[l], v[r-1])
    if(comp(&v[l], &v[r]) > 0) exch(v[l], v[r])
    if(comp(&v[r-1], &v[r]) > 0) exch(v[r], v[r-1])
}

void medianL(Item *v, int l, int r, Compare comp)
{
    int m = (l+r)/2;
    exch(v[m], v[l+1])
    if(comp(&v[l+1], &v[r]) > 0) exch(v[r], v[l+1])
    if(comp(&v[l], &v[r]) > 0) exch(v[l], v[r])
    if(comp(&v[l], &v[l+1]) > 0) exch(v[l], v[l+1])
}

void quick_sortM3(Item *v,  int l, int r, Compare comp)
{
    if(r<=l) return;
    //if(r-l<=15) return;
    //if(r-l<=15) return insertion(v, l, r);

    medianL(v, l, r, comp);

    int p = partitionLSEDGEWICK(v, l+1, r-1, comp);

	quick_sortM3(v, l, p-1, comp);
	quick_sortM3(v, p+1, r, comp);
}


void quick_sortM3I(Item *v,  int l, int r, Compare comp)
{
    //if(r<=l) return;
    //if(r-l<=15) return;
    if(r-l<=15) return insertion(v, l, r, comp);
    
    //exch(v[(l+r)/2], v[r-1]);
    //compexch(v[l], v[r-1]);
    //compexch(v[l], v[r]);
    //compexch(v[r-1], v[r]);
    medianR(v, l, r, comp);

    int p = partitionRSEDGEWICK(v, l+1, r-1, comp);
	quick_sortM3I(v, l, p-1, comp);
	quick_sortM3I(v, p+1, r, comp);
}

