void selection(Item v[], int l, int r, Compare comp)
{
    int menor;
    for(int i=l; i<r; i++) 
    {
        menor = i;
        for(int j=i+1; j<=r; j++) 
            if(comp(&v[j], &v[menor])<  0)
                menor = j;

        if(i != menor) exch(v[i], v[menor])
    }

    //recursivo
    /* if(l>r) return;
    int menor = l;
    for(int j=l+1; j<=r; j++)
        if(comp(v[j],v[menor]))
            menor = j;
        
    if(l != menor) exch(v[l], v[menor])
    selection(v, l+1, r, comp); */
}

void bubble(Item v[], int l, int r, Compare comp)
{
    int swap = 1;
    while(r>l && swap)
    {
        swap = 0;
        for(int j=l; j<r; j++) {
            if(comp(&v[j+1], &v[j])<0){ 
                exch(v[j], v[j+1])
                swap = 1;
            }
        }
        r--;
    }
}

void shaker(Item v[], int l, int r, Compare comp)
{
    int swap = 1;
    for(; swap && l<=r; l++, r--){
        swap = 0;
        for(int j=l; j<r; j++) {
            if(comp(&v[j+1], &v[j])<0) { 
                exch(v[j], v[j+1])
                swap = 1;
            }
        }

        for(int j=r; j>l; j--) {
            if(comp(&v[j], &v[j-1])<0){ 
                exch(v[j], v[j-1])
                swap = 1;
            }
        }
    }
}

void insertion(Item v[], int l, int r, Compare comp)
{
    Item elem;
    int i, j;
    for(i=l+1; i<=r; i++)
    {
        elem = v[i];
        for(j=i; j>l && comp(&elem, &v[j-1])<0; j--)
            v[j] = v[j-1];
        
        v[j] = elem;
    }

    //simples
    /* for(int i=l+1; i<=r; i++){
        for(int j=i; j>l && comp(v[j],v[j-1]); j--)
            exch(v[j], v[j-1])
    } */

    //pré-ordenação
    /* for(i=r; i>l; i--) {
        compexch(v[l], v[i])
    }
      
    for(i=l+2; i<=r; i++)
    {
        elem = v[i];
        for(j=i; comp(elem,v[j-1]); j--)
            v[j] = v[j-1]; //puxando o maior
        
        v[j] = elem; //encaixando o elemento
    } */
    
}

void shell(Item v[], int l, int r, Compare comp)
{
    int h = 1, i, j;
    while(h < (r-l+1)/3) h = 3*h+1;

    while(h>=1){
        for(i=l+h; i<=r; i++)
        {
            Item elem = v[i];
            for(j=i; j>=l+h && comp(&elem, &v[j-h])<0; j-=h)
            {
                v[j] = v[j-h];
            }
            v[j] = elem;
        }
        h = h/3;
    }
}