//https://www.ime.usp.br/~pf/algoritmos/aulas/ordena.html
//https://brunoribas.com.br/apostila-eda/ordenacao-elementar.html
//https://github.com/bcribas/benchmark-ordenacao

#include "ordenacao.h"
#include "ordenacao-elementar.c"
#include "ordenacao-eficiente.c"

long milliseconds()
{
    struct timeval tp;
    gettimeofday(&tp, NULL);
	return tp.tv_sec * 1000 + tp.tv_usec / 1000;
}

void show(Item v[], int l, int r)
{
    for(int i=l; i<=r; i++){
        printf("%d ", v[i]);
    }
    printf("\n");
}

int is_sorted(Item v[], int l, int r, Compare comp)
{
    int p;
    for(p=r; p>l && comp(&v[p-1], &v[p])<=0; p--);

    return (p==l);
}

int check(const void* v1, const void* v2)
{
    const Item *a = v1;
    const Item *b = v2;
    return key(*a) - key(*b); //0  v1 = v2
                              //-  v1 < v2
                              //+  v1 > v2
}   

int crescente(const void* v1, const void* v2){ //v1 < v2
    return check(v1, v2); //- se v1 < v2
}

int decrescente(const void* v1, const void* v2){ //v1 > v2
    return check(v2, v1); //- se v2 < v1, ou seja, v1 > v2
}